<script setup lang="ts">
import SystemInfoTable from '../SystemInfoTable/SystemInfoTable.vue';
import { ref, toRefs } from 'vue';
import type { PropType } from 'vue';
import { IOtherTab, IDiskBackplane } from '../../product.datatype';
import { getBoard } from '../../service/system.service';
import { isOtherEmptyProperty } from '../../utils/system.util';

const props = defineProps({
  data: {
    type: Object as PropType<IOtherTab>,
    required: true,
    default: () => {
      return {};
    },
  },
});
const tableId = 'diskBackPlaneTable';
const { data } = toRefs(props);
const boardData: IOtherTab = data?.value;
const boardTableData = ref([] as any);
const boardShow = ref(false);

if (boardData.currentNumber && boardData.currentNumber > 0) {
  getBoard(boardData.detailLink).then((res: any) => {
    if (res.data && res.data.length > 0) {
      res.data.forEach((borad: any) => {
        const d = parseData(borad);
        if (d) {
          boardTableData.value.push(d);
        }
      });
    }
    boardShow.value = true; // 异步请求，等请求结束才能显示
  });
} else {
  boardShow.value = true; // 为了显示表头
}

function parseData(board: any): IDiskBackplane {
  return {
    boardName: isOtherEmptyProperty(board.BoardName),
    manufacturer: isOtherEmptyProperty(board.Manufacturer),
    cardNo: isOtherEmptyProperty(board.CardNo),
    pCBVersion: isOtherEmptyProperty(board.PCBVersion),
    cPLDVersion: isOtherEmptyProperty(board.CPLDVersion),
    boardId: isOtherEmptyProperty(board.BoardID),
    location: isOtherEmptyProperty(board.Location),
    description: isOtherEmptyProperty(board.Description),
    partNumber: isOtherEmptyProperty(board.PartNumber),
    serialNumber: isOtherEmptyProperty(board.SerialNumber),
  };
}

const columns = [
  {
    title: 'COMMON_NAME',
    width: '10%',
    show: true,
    content: 'boardName',
  },
  {
    title: 'OTHER_POSITION',
    width: '10%',
    show: true,
    content: 'location',
  },
  {
    title: 'COMMON_MANUFACTURER',
    width: '10%',
    show: true,
    content: 'manufacturer',
  },
  {
    title: 'COMMON_NUMBER',
    width: '5%',
    show: true,
    content: 'cardNo',
  },
  {
    title: 'COMMON_TYPE',
    width: '17%',
    show: true,
    content: 'description',
  },
  {
    title: 'COMMON_ALARM_PCB_VERSION',
    width: '8%',
    show: true,
    content: 'pCBVersion',
  },
  {
    title: 'COMMIN_CPLD_VERSION',
    width: '8%',
    show: true,
    content: 'cPLDVersion',
  },
  {
    title: 'OTHER_BOARD_ID',
    width: '8%',
    show: true,
    content: 'boardId',
  },
  {
    title: 'OTHER_PART_NUMBER',
    width: '10%',
    show: true,
    content: 'partNumber',
  },
  {
    title: 'COMMON_SERIALNUMBER',
    width: '14%',
    show: true,
    content: 'serialNumber',
  },
];
</script>

<template>
  <SystemInfoTable
    v-if="boardShow"
    :id="tableId"
    :data="boardTableData"
    :columns="columns"
    :num="boardData.maxNumber"
  />
</template>

<style lang="scss" scoped></style>
